import { NextHandler, RequestChunk, ResponseChunk, Streamer } from "./streamer";
import { CachePlugin } from "./cache-factory";
interface CacheDecoratedResponse extends ResponseChunk {
    cacheHit: boolean;
}
interface CacheDecoratedRequest extends RequestChunk {
    cacheHit: boolean;
}
declare class CacheThenNetwork extends Streamer {
    private readonly storage;
    private readonly ms?;
    private readonly cacheWithCookie;
    constructor(plugin: CachePlugin, cacheWithCookie?: boolean, ms?: number);
    onResponse(chunk: CacheDecoratedResponse, next: NextHandler): Promise<void>;
    onRequest(chunk: CacheDecoratedRequest, next: NextHandler): Promise<void>;
}
export { CacheThenNetwork };
